/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018, 2024 (c)
 * 
 *    file: module_pas.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_pas[] = { "pas", "PAS" };
wchar_t *keyword_pas[] = {
      //GNU Pascal language keywords
      L"absolute",
      L"abstract",
      L"all",
      L"and",
      L"and_then",
      L"array",
      L"asm",
      L"asmname",
      L"as",
      L"attribute",
      L"begin",
      L"bindable",
      L"case",
      L"c_language",
      L"class",
      L"constructor",
      L"const",
      L"destructor",
      L"div",
      L"downto",
      L"double",
      L"else",
      L"end",
      L"exports",
      L"export",
      L"external",
      L"far",
      L"filepos",
      L"finalization",
      L"forward",
      L"formatstring",
      L"function",
      L"goto",
      L"if",
      L"implementation",
      L"import",
      L"inherited",
      L"initializaion",
      L"interface",
      L"interrupt",
      L"include",
      L"is",
      L"label",
      L"library",
      L"module",
      L"mod",
      L"name",
      L"near",
      L"nil",
      L"not",
      L"object",
      L"of",
      L"only",
      L"operator",
      L"or_else",
      L"ord",
      L"otherwise",
      L"packed",
      L"pow",
      L"private",
      L"procedure",
      L"program",
      L"property",
      L"protected",
      L"public",
      L"published",
      L"qualified",
      L"record",
      L"repeat",
      L"resident",
      L"restricted",
      L"segment",
      L"setfiletime",
      L"shl",
      L"shr",
      L"then",
      L"to",
      L"typeof",
      L"unit",
      L"until",
      L"uses",
      L"value",
      L"var",
      L"view",
      L"virtual",
      L"while",
      L"with",
      L"xor",
      ///////////////////////////////////////////
      L"abs",
      L"addr",
      L"alignof",
      L"ansichar",
      L"anyfile",
      L"append",
      L"arccos",
      L"arcsin",
      L"arctan",
      L"arg",
      L"assert",
      L"assigned",
      L"assign",
      L"bindingtype",
      L"binding",
      L"bind",
      L"bitsizeof",
      L"blockread",
      L"blockwrite",
      L"boolean",
      L"break",
      L"byteint",
      L"bytecard",
      L"byteint",
      L"byte",
      L"cardinal",
      L"card",
      L"cintean",
      L"ccardinal",
      L"char",
      L"chdir",
      L"chr",
      L"cinteger",
      L"close",
      L"cmplx",
      L"complex",
      L"compilerassert",
      L"comp",
      L"concat",
      L"conjugate",
      L"continue",
      L"copy",
      L"cos",
      L"cstring2string",
      L"cstringcopystring",
      L"cstring",
      L"currentroutinename",
      L"cword",
      L"cycle",
      L"date",
      L"dec",
      L"definesize",
      L"delete",
      L"discard",
      L"dispose",
      L"do",
      L"empty",
      L"eof",
      L"eoln",
      L"epsreal",
      L"eqpad",
      L"eq",
      L"erase",
      L"exclude",
      L"exit",
      L"exp",
      L"extended",
      L"extend",
      L"fail",
      L"false",
      L"filesize",
      L"file",
      L"fillchar",
      L"finalize",
      L"flush",
      L"forward",
      L"for",
      L"frac",
      L"frameaddress",
      L"freemem",
      L"gepad",
      L"getmem",
      L"gettimestamp",
      L"get",
      L"ge",
      L"gtpad",
      L"gt",
      L"im",
      L"inc",
      L"index",
      L"initialize",
      L"inoutres",
      L"input",
      L"insert",
      L"integer",
      L"ioresult",
      L"int",
      L"in",
      L"lastposition",
      L"leave",
      L"length",
      L"lepad",
      L"le",
      L"ln",
      L"locase",
      L"longint",
      L"longcard",
      L"longestint",
      L"longestcard",
      L"longestint",
      L"longestreal",
      L"longestword",
      L"longint",
      L"longreal",
      L"longword",
      L"low",
      L"ltpad",
      L"lt",
      L"mark",
      L"maxchar",
      L"maxint",
      L"maxreal",
      L"max",
      L"medint",
      L"medcard",
      L"medint",
      L"medreal",
      L"medword",
      L"minreal",
      L"min",
      L"mkdir",
      L"moveleft",
      L"moveright",
      L"move",
      L"nepad",
      L"newcstring",
      L"new",
      L"ne",
      L"null",
      L"odd",
      L"or",
      L"output",
      L"pack",
      L"page",
      L"pansichar",
      L"paramcount",
      L"paramstr",
      L"pchar",
      L"pi",
      L"pobjecttype",
      L"pointer",
      L"polar",
      L"position",
      L"pos",
      L"pred",
      L"ptrcard",
      L"ptrdifftype",
      L"ptrint",
      L"ptrword",
      L"put",
      L"randomize",
      L"random",
      L"readstr",
      L"readln",
      L"read",
      L"real",
      L"release",
      L"rename",
      L"reset",
      L"result",
      L"returnaddress",
      L"return",
      L"rewrite",
      L"rmdir",
      L"re",
      L"round",
      L"runerror",
      L"seekwrite",
      L"seekupdate",
      L"seekread",
      L"seekeoln",
      L"seekeof",
      L"seek",
      L"self",
      L"setlength",
      L"settype",
      L"set",
      L"shortint",
      L"shortcard",
      L"shortint",
      L"shortreal",
      L"shortword",
      L"single",
      L"sin",
      L"sizeof",
      L"sizetype",
      L"smallint",
      L"sqrt",
      L"sqr",
      L"standarderror",
      L"standardinput",
      L"standardoutput",
      L"stderr",
      L"string2cstring",
      L"string",
      L"str",
      L"substr",
      L"succ",
      L"text",
      L"timestamp",
      L"time",
      L"trim",
      L"true",
      L"truncate",
      L"trunc",
      L"type",
      L"unbind",
      L"unpack",
      L"upcase",
      L"update",
      L"val",
      L"void",
      L"wordint",
      L"word",
      L"writeln",
      L"writestr",
      L"write",
};

struct modulestruct module_pas =
{
    .extsCount      = 2,
    .exts           = ext_pas,
    .keywordCount   = 315,
    .keywords       = keyword_pas,
    .mlCommentStart = L"{*",
    .mlCommentEnd   = L"*}",
    .slCommentStart = L"{",
    .caseSensitive  = 0,
};

